#ifndef SM_Soubory_h
#define SM_Soubory_h
#include <BK/Soubory.h>
#include <BK/String.h>
////////////////////////////////////////////////////////////////////////////////
//                           S   A   V   E                                    //
////////////////////////////////////////////////////////////////////////////////
#define PREPIS  2
void SMSoubor ( SM sm, int flags=PREPIS )
{ const CHAR* filter = "Sezn. m. MAPA2 (*.zap)\0*.zap\0Sezn. m. a souadnic GAMA-XML (*.gkf)\0*.gkf\0Vechny soubory (*.*)\0*.*\0";
  PRO pripony;     pripony.push_back(".zap"); pripony.push_back(".gkf");
  string SFN; int FilterIndex;
  if( !GetSFN(SFN,pripony,FilterIndex,filter) ) return;

  fstream out;
  
  if( FilterIndex==2 ) { SaveGKF( ss, sm, SFN ); return; }
  else

  if( Flags(flags,PREPIS) ) out.open( SFN.c_str() ,ios_base::out);
  else out.open( SFN.c_str() ,ios_base::out|ios_base::app);

////////////////////         M   A   P   A   2        //////////////////////////
// HLAVIKA
  out << "9999" << endl
      << "999999999" << endl
      << "100001" << endl
      << "1" << endl
      << "3" << endl
      << "0" << endl
      << "2" << endl;
// MEN
  for(SM::iterator i=sm.begin(); i!=sm.end(); i++)
  { string CBs=i->first;
    ST::iterator i=sm[CBs].begin(); // prvn bod stanoviska
    double vp=sm[CBs][i->first].vp;

    out <<  1 << " " << Width(CBs,0,Original|BezNul) << " " << WidthNum(vp,6) << endl;
    
    bool orientace=true;
    for(int o=0; o<2; o++) // 2x (or a pb)
    { for(i=sm[CBs].begin(); i!=sm[CBs].end(); i++)
      { string CBc=i->first;  Mereni m=i->second;
          if( orientace & m.Or==' ' ) continue;
          if(!orientace & m.Or=='o' ) continue;
        string D;
        char hvezdicka;
        if(m.poznamka.size()==0) hvezdicka=' ';
        else hvezdicka='*';
  
        sprintf(gChar,"  % 12s  %c % 10s % 8s % 10s % 10s %c%s",
           Width(CBc,0,Original+BezNul).c_str(),
           m.tD,
           Width(m.D,10,Nula+Delka).c_str(),
           Width(m.vc,8,Nula+Delka).c_str(),
           Width(m.Hz,10,Nula+Uhel).c_str(),
           Width(m.Z,10,Nula+Uhel).c_str(),
           hvezdicka,
           m.poznamka.c_str() );
        out << gChar << endl;
      }
    if(orientace) { out << -1 << endl; orientace=false;  }
    }  
  out << '/' << endl;
  }
  out << -2 << endl;
}



////////////////////////////////////////////////////////////////////////////////
//                           O   P   E   N                                    //
////////////////////////////////////////////////////////////////////////////////
struct MapaMer{ 
  PRO seznam;
  string komentar, poznamka, puvodni;
  double domerek, kolmice;
  
  MapaMer(string vst)
  { if( vst.size()==0 ) return;
    puvodni = vst;
    komentar = StrTake (vst,";","",End); StrTake (komentar,";");
    poznamka = StrTake (vst,"*","",End); StrTake (poznamka,"*");
    string dom_kol = StrTake (vst,":","",End); StrTake (dom_kol,":");
    
    stringstream ss(vst);
    string s;
    while (ss >> s) seznam.push_back(s);
    
    if( dom_kol.size()!=0 )
    { stringstream ss2(dom_kol);
      string a;
      while (ss >> s >> a)
        if( s.size()!=0 & JeReal(s) & a.size()!=0 & JeReal(a) )
        { domerek = Double(s); kolmice = Double(a); }
    }
  }
};

void SouborSM ()
{ const CHAR* filter = "Namen data MAPA2 (*.asc; *.zap)\0*.asc;*.zap\0Vechny soubory (*.*)\0*.*\0";
  string OFN; if( !GetOFN(OFN,filter) ) return;

  chyby.clear();
  ifstream vstup( OFN.c_str() );
  
  string radek;
  vector<MapaMer> mapa;
  // nacteni vsech radku
  while( getline(vstup,radek) )
    mapa.push_back(MapaMer(radek));
  // zacatek mereni
  int zm;
  for(zm=0; zm<mapa.size()-3; zm++)
  { PRO s = mapa[zm+1].seznam;
    if( s.size()==1 & s[0]=="-1" | s.size()>3 ) break;
    if( s.size()==3 ) if( JeReal(s[1]) ) if( Double(s[1])==0 ) break;
  }
  try{ if( zm>mapa.size()-5 )
    throw Chyba("Soubor neobsahuje men ve formtu MAPA!"); }
  catch (Chyba ch) { ch.MB();  return; }
  // hlavicka
  PRO hlavicka;
  if(zm>6)
    for(int i=0; i<zm; i++)
      if( mapa[i].seznam.size()==1 ) if( JeCele(mapa[i].seznam[0]) )
        hlavicka.push_back(mapa[i].seznam[0]);
  // ma hlavicku:
  if( hlavicka.size()==7 )
    if( hlavicka[6].size()==1 ) gtD=hlavicka[6][0];

// NACTENI DO SM ///////////////////////////////////////////////////////////////
  char st, o, pb, typ; 
  st='s'; o='o'; pb='p'; typ=st;
  string CBs,vp,CBc,D,vc,Hz,Z; char Or,tD;

  for(int i=zm; i<mapa.size(); i++)
  { CBc=D=vc=Hz=Z="";

    try {
    PRO s = mapa[i].seznam;
    if( s.size()==0 ) continue;
    
    if( s[0]=="-1" ) { typ=pb; continue; }
    if( s[0]=="/" )  { typ=st; continue; }
    if( s[0]=="-2" ) break;
    // stanovisko
    if( typ==st )
    { CBs=vp="";
      if( s.size()==1 ) { CBs=s[0]; vp="0"; }
      if( s.size()==2 )
        if( JeCele(s[0]) & JeCb(s[1]) )
        { CBs=s[1]; vp="0";
          if( s[0]!="1" )
          { throw Chyba("Ppustn typ lohy je pouze '1' (polrn metoda).");
            while( s[0]!="/" | s[0]!="-2" ) i++; i--;
          }
        }
        else { CBs=s[0]; vp=s[1]; }
      if( s.size()==3 )
      { CBs=s[1]; vp=s[2];
        if( s[0]!="1" )
        { throw Chyba("Ppustn typ lohy je pouze '1' (polrn metoda).");
          while( s[0]!="/" | s[0]!="-2" ) i++; i--;
      } }
      typ=o; continue;
    }
    // podrobn bod a orientace
    if( typ==pb ) Or=' ';
    if( typ==o )  Or='o';
    
    if( JeCele(s[1]) & s[1].size()==1 ) // je tD
    { if( s.size()<4 ) throw Chyba ("Mlo daj na dku - dek nenaten!");
      if( s.size()>6 ) throw Chyba ("Mnoho daj na dku - dek nenaten!");
      tD = s[1][0];
      D  = Real(s[2]);
      if( s.size()==4 ) { vc=vp; Hz=Real(s[3]); }
      if( s.size()==5 ) { vc=vp; Hz=Real(s[3]); Z=Real(s[4]); }
      if( s.size()==6 ) { vc=Real(s[3]); Hz=Real(s[4]); Z=Real(s[5]); }
    }
    else // neni tD
    { if( s.size()<3 ) throw Chyba ("Mlo daj na dku - dek nenaten!");
      if( s.size()>5 ) throw Chyba ("Mnoho daj na dku - dek nenaten!");
      tD = gtD;
      D  = Real(s[1]);
      if( s.size()==3 ) { vc=vp; Hz=Real(s[2]); }
      if( s.size()==4 ) { vc=vp; Hz=Real(s[2]); Z=Real(s[3]); }
      if( s.size()==5 ) { vc=Real(s[2]); Hz=Real(s[3]); Z=Real(s[4]); }
    }
    
    CBs = Cb(CBs);
    CBc = Cb(s[0]);
    // naplneni SM:
    if(DuplMer (CBs,CBc)) throw Chyba ("Duplicitn smr men stanovisko->cl - men nepidno!");

    if(vp.size()!=0) sm[CBs][CBc].vp=Double(vp);
    sm[CBs][CBc].Or=Or;
    sm[CBs][CBc].tD=tD;
    sm[CBs][CBc].D=Double(D);
    sm[CBs][CBc].vc=Double(vc);
    sm[CBs][CBc].Hz=Double(Hz);
    if(Z.size() !=0) sm[CBs][CBc].Z=Double(Z);
    if(mapa[i].poznamka.size()!=0) sm[CBs][CBc].poznamka=mapa[i].poznamka;

    } catch (Chyba ch) { string x="dek .: "+Cb(i,4);
        ch.titulek="     "+mapa[i].puvodni; chyby[x]=ch; }
  }
  SMDlg ();
  if( chyby.size()!=0 )
    DialogBox (ghInst, MAKEINTRESOURCE (IDD_CHDIALOG), ghMainDlg, ChDlgProc );
}

#endif
